@echo off
REM --------------------------------------------
REM    UG-Version der CAD-Maschinen ermitteln
REM --------------------------------------------
REM 
REM  Aufruf:
REM   get-ug-versions-from-cadhosts.bat HOST [HOST ...]
REM 
REM --------------------------------------------



echo UG-Version-Result for CAD-machines: > c:\temp\ugvers.log

REM Schleife ueber alle Rechner der Parameterliste 
FOR %%x IN ( %* ) DO call :SUB_check-machine %%x

goto :endOfProg





REM --------------------------------------------
REM 
REM              Sub-Routine
REM 
REM --------------------------------------------

:SUB_check-machine
set MACHINE=%1
echo.
echo.
echo.
echo -------------------------
echo ping on %MACHINE%
REM is the machine reachable at all?
ping -n 1 -w 200 %MACHINE%
if NOT %ERRORLEVEL%==0 echo %MACHINE% - Could not be reached by ping >> c:\temp\ugvers.log
if NOT %ERRORLEVEL%==0 goto :endsub

echo -------------------------
echo log on %MACHINE%
REM connect ...
set oldPW=
echo on
net use \\%MACHINE%\d$ /user:%MACHINE%\MYUSER MYPASSWORT                       <------ EDIT!
@echo off
if NOT %ERRORLEVEL%==0 (
  echo %MACHINE% - Could not login >> c:\temp\ugvers.log
  goto :endsub )

set UgDrive=d$
If NOT Exist \\%MACHINE%\d$\ugnx2\ugii\ugraf.exe (
  REM UG is on C:\ - hopefuly, because its not on D:\ 

  REM disconnect d$ and connect to c$
  net use \\%MACHINE%\d$ /d  >NUL
  net use \\%MACHINE%\c$ /user:%MACHINE%\\MYUSER MYPASSWORT                       <------ EDIT!
  if NOT %ERRORLEVEL%==0 (
    echo %MACHINE% - Could not login to C$ >> c:\temp\ugvers.log
    goto :endsub )
set UgDrive=c$ )





REM Try to get the Version and MaintenancePack number:
REM  The patch number is as text in the libpatch.dll which could be asked with UG_ask_patch_text() or by just grep after it:  "Unigraphics NX 2.0.6.2, MP 4..."
REM  - get the last matching line from the file
REM  - read 1st char, see if there is on or string was empty.
REM  - check if char is "M", if not cut it off and restart loop
REM  - if its an "M", check if next is a "P". If not, restart loop
REM  - if it is, take the whole string up to the next 4 chars as result

set RESULTSTR=
If NOT EXIST \\%MACHINE%\%UgDrive%\ugnx2\ugii\libpatch.dll goto :END_MP_LOOP

For /F "Tokens=*" %%A In ( 'find "Maintenance Pack letter" \\%%MACHINE%%\%%UgDrive%%\ugnx2\ugii\libpatch.dll' ) DO call set FOUNDSTR=%%A
if "%FOUNDSTR:~0,10%" EQU "----------" (
  set UGPATCH=[no MP]
  goto :END_MP_LOOP )
set UGPATCH=%FOUNDSTR%
:FIND_MP_LOOP
if "%UGPATCH%X"=="X" (
  set UGPATCH=[no MP]
  goto :END_MP_LOOP )
set myToken=%UGPATCH:~0,1%
if "%myToken%" NEQ "M" (
  REM echo "%UGPATCH%"
  set RESULTSTR=%RESULTSTR%%UGPATCH:~0,1%
  set UGPATCH=%UGPATCH:~1,2000%
  goto :FIND_MP_LOOP)
if "%myToken%" EQU "M" (
  set nextToken=%UGPATCH:~1,1%
  if "%nextToken%" NEQ "P" (
    goto :FIND_MP_LOOP
    set RESULTSTR=%RESULTSTR%%UGPATCH:~0,2%
    set UGPATCH=%UGPATCH:~2,2000%)
  set RESULTSTR=%RESULTSTR%%UGPATCH:~0,4%
  set UGPATCH=%UGPATCH:~0,4%)
:END_MP_LOOP
set myToken=

REM No MP? -> get the UG _version_ with d:\ugnx2\ugii\env_print.exe -v
if "%RESULTSTR%X"=="X"  For /F "Tokens=*" %%A In ( '\\%%MACHINE%%\%%UgDrive%%\ugnx2\ugii\env_print.exe -v' ) DO call set RESULTSTR=%%A [no MP]

echo %MACHINE% - UG-Version is %RESULTSTR% %oldPW% %UgDrive% >> c:\temp\ugvers.log
echo %MACHINE% - UG-Version is %RESULTSTR% %oldPW% %UgDrive%
set RESULTSTR=


REM disconnect ...
net use \\%MACHINE%\%UgDrive% /d  >NUL
goto :endsub



:endsub
echo -------------------------
goto :EOF


:endOfProg
